<?php
    // Setup PHP Enviropment
    error_reporting(E_ALL & ~E_NOTICE);
    // Define Contants
    define('THIS_SCRIPT', 'discuss');
    define('GET_EDIT_TEMPLATES', 'add,edit');
    // Cache Templates & Variables
    // get special phrase groups
    $phrasegroups = array(
	    'discuss',
	    'postbit',
	    'posting'
    );
    $specialtemplates = array(
        'smiliecache',
	    'bbcodecache',
	    'attachmentcache',
    );
    $globaltemplates = array(
		'discuss.css',
        'discuss_main',
        'discuss_horizontal_categories',
        'discuss_horizontal_categories_bit',
        'discuss_subcategories_bit',
        'discuss_view_question',
        'discuss_about_author_block',
		'discuss_author_questions_block',
		'discuss_author_questions_bit',
		'discuss_experts_block',
		'discuss_experts_block_bit',
        'discuss_statistics_block',
        'discuss_search_block',
		'discuss_newest_questions',
		'discuss_popular_questions',
		'discuss_browse_open',
		'discuss_browse_closed',
		'discuss_browse_replies',
		'discuss_search_results',
		'discuss_search_results_bit',
        'im_aim',
        'im_icq',
        'im_msn',
        'im_skype',
        'im_yahoo',
        'im_send_aim',
        'im_send_icq',
        'im_send_msn',
        'im_send_skype',
        'im_send_yahoo',
        'im_message',
	    'bbcode_code',
	    'bbcode_html',
	    'bbcode_php',
	    'bbcode_quote',
        'editor_toolbar_on'
    );
    $actiontemplates = array();
    // Include Globals
    require_once('./global.php');
    require_once('./includes/functions_editor.php');
    require_once('./includes/functions_newpost.php');
    require_once('./includes/functions_user.php');
    require_once('./includes/class_bbcode.php');
    require_once('./includes/class_image.php');
    require_once('./includes/functions_bigthree.php');
    require_once('./includes/class_dm.php');
    require_once('./includes/class_dm_pm.php');
    require_once('./discuss/includes/functions.php');
    require_once('./includes/class_bootstrap_framework.php');
    vB_Bootstrap_Framework::init();
//  #######################################################################
//  ########################  Minimum Permissions  ########################
//  #######################################################################
    // Check Permissions to Access this section
    if(!($permissions['discuss'] & $vbulletin->bf_ugp['discuss']['access']))
    {
        print_no_permission();
    }
//  #######################################################################
//  ###########################  Default Action  ##########################
//  #######################################################################
    // Select Action
    if (empty($_REQUEST['do']))
    {
	    $_REQUEST['do'] = 'main';
    }
//  #######################################################################
//  ###############################  Index Page  ##########################
//  #######################################################################
if ($_REQUEST['do'] == 'main')
{
    $vbulletin->input->clean_gpc('r', 'catid', TYPE_UINT);
    if(!isset($_REQUEST['catid']))
    {
       $catid = 0;
	   $categoryname = '';
    } else {
       $catid = $_REQUEST["catid"];
	   $sql_category = $db->query_first("SELECT name FROM ".TABLE_PREFIX."discuss_categories WHERE id=$catid LIMIT 1");
	   $categoryname = $sql_category["name"];
    }
    if(!isset($_REQUEST['infotab']))
    {
       $infotab = 1;
    } else {
       $infotab = $_REQUEST["infotab"];
    }	
    if(!isset($_REQUEST['cattab']))
    {
       $cattab = 1;
    } else {
       $cattab = $_REQUEST["cattab"];
    }		
    $blocks = $vbulletin->options["discuss_menu_blocks"];
    $hcategories = getHorizontalCategories($catid,$blocks);
    // Custom Navbar
    $mynavbar = '';
    $mynavbar = getNavBar($mynavbar, $catid);
    // Activate or not Followup link
    $viewerid = $vbulletin->userinfo['userid'];
    $allowfollowup = getFollowUp($catid,$viewerid);
	// Show or Not Questions
    if ($catid <= 0)
    {
        $showgrid = 0;
		if ($infotab == 1)
		{
			// Newest Questions
			$maximum = $vbulletin->options["discuss_newest"];
			$datarows = $db->query_read("SELECT * FROM ".TABLE_PREFIX."discuss_questions WHERE approved=1 AND hidden=0 AND resolved=0 ORDER BY postdate DESC LIMIT $maximum");
			while ($datarow = $db->fetch_array($datarows)) {
					$seolink = $vbulletin->options["bburl"].'/discuss.php?do=viewquestion&questionid='.$datarow['id'];
					//  keywords clickable
					$keywords = '';
					if(!empty($datarow["keywords"]))
					{
						$tagIds = $datarow["keywords"];
						$tagArray = explode(',', $tagIds);
						foreach($tagArray as $tid){
							$keywords .= "<span class='keywords'>&nbsp;<a class='smallfont' href='discuss.php?do=searchresults&keyword=". $tid ."'>#".$tid."</a>&nbsp;</span>&nbsp;";
						}
					}	
					// User Avatar
					$useravatarurl = fetch_avatar_url($datarow["userid"]);
					if (!$useravatarurl)
					{
						$useravatar = 'discuss/images/avatar.png';
					} else {
						$useravatar = $vbulletin->options['bburl'] . '/' . $useravatarurl[0];
					}			   
					$templater = vB_Template::create('discuss_newest_questions');
					$templater->register('datarow_id', $datarow[id]);
					$templater->register('datarow_categoryid', $datarow[categoryid]);
					$templater->register('datarow_categoryname', $datarow[categoryname]);
					$templater->register('datarow_title', $datarow[title]);
					$templater->register('datarow_seolink', $seolink);
					$templater->register('datarow_keywords', $keywords);
					$templater->register('datarow_userid', $datarow[userid]);
					$templater->register('datarow_username', $datarow[username]);
					$templater->register('datarow_useravatar', $useravatar);
					$templater->register('datarow_replies', $datarow[replies]);
					$templater->register('datarow_featured', $datarow[featured]);
					$templater->register('datarow_views', $datarow[views]);
					$templater->register('datarow_resolved', $datarow[resolved]);
					$templater->register('datarow_postdate', time_stamp($datarow[postdate]));
					$newest_questions .= $templater->render();
			}
		}
		if ($infotab == 2)
		{
			// Popular Questions
			$maximum = $vbulletin->options["discuss_newest"];
			$datarows = $db->query_read("SELECT * FROM ".TABLE_PREFIX."discuss_questions WHERE approved=1 AND hidden=0 AND resolved=0 AND replies>0 ORDER BY replies DESC LIMIT $maximum");
			while ($datarow = $db->fetch_array($datarows)) {
					$seolink = $vbulletin->options["bburl"].'/discuss.php?do=viewquestion&questionid='.$datarow['id'];
					//  keywords clickable
					$keywords = '';
					if(!empty($datarow["keywords"]))
					{
						$tagIds = $datarow["keywords"];
						$tagArray = explode(',', $tagIds);
						foreach($tagArray as $tid){
							$keywords .= "<span class='keywords'>&nbsp;<a class='smallfont' href='discuss.php?do=searchresults&keyword=". $tid ."'>#".$tid."</a>&nbsp;</span>&nbsp;";
						}
					}	
					// User Avatar
					$useravatarurl = fetch_avatar_url($datarow["userid"]);
					if (!$useravatarurl)
					{
						$useravatar = 'discuss/images/avatar.png';
					} else {
						$useravatar = $vbulletin->options['bburl'] . '/' . $useravatarurl[0];
					}			   
					$templater = vB_Template::create('discuss_popular_questions');
					$templater->register('datarow_id', $datarow[id]);
					$templater->register('datarow_categoryid', $datarow[categoryid]);
					$templater->register('datarow_categoryname', $datarow[categoryname]);
					$templater->register('datarow_title', $datarow[title]);
					$templater->register('datarow_seolink', $seolink);
					$templater->register('datarow_keywords', $keywords);
					$templater->register('datarow_userid', $datarow[userid]);
					$templater->register('datarow_username', $datarow[username]);
					$templater->register('datarow_useravatar', $useravatar);
					$templater->register('datarow_replies', $datarow[replies]);
					$templater->register('datarow_featured', $datarow[featured]);
					$templater->register('datarow_views', $datarow[views]);
					$templater->register('datarow_resolved', $datarow[resolved]);
					$templater->register('datarow_postdate', time_stamp($datarow[postdate]));
					$popular_questions .= $templater->render();
			}
		}			
    } else {
		$showgrid = 1;
		if ($cattab == 1)
		{
			$questionsperpage = $vbulletin->options['discuss_perpage'];
			$SubIds = array();
			$getSub = _getChildId($SubIds, $catid);
			$categories = implode($SubIds, ', ');
			$sql = "SELECT * FROM ".TABLE_PREFIX."discuss_questions WHERE categoryid IN ($categories) AND approved=1 AND hidden=0 AND resolved=0 ORDER BY postdate DESC";
			// Count records for pagination
			$totalquestions = $db->query_read($sql);
			$questions = $db->num_rows($totalquestions);
			$perpage= $questionsperpage;
			$pagenumber = $vbulletin->input->clean_gpc('r', 'pagenumber', TYPE_UINT);
			if (empty($pagenumber))
			{
				$pagenumber = 1;
			}
			$limitlower = ($pagenumber - 1) * $perpage+1;
			$limitupper = ($pagenumber) * $perpage;
			$counter = 0;
			if ($limitupper > $records)
			{
				$limitupper = $records;
				if ($limitlower > $records)
				{
					$limitlower = $records-$perpage;
				}
			}
			if ($limitlower <= 0)
			{
				$limitlower = 1;
			}
			$pagenav = construct_page_nav($pagenumber, $perpage, $records, 'discuss.php?' . $vbulletin->session->vars['sessionurl'] . 'do=main&catid='.$catid.'&cattab=1');
			// We must add limit to sql
			$sql .= ' LIMIT '. ($limitlower - 1) .', '.$perpage;
			// Execute Query
			$sql_questions = $db->query_read($sql);
			// Build Bits
			while ($question = $vbulletin->db->fetch_array($sql_questions)){
					$seolink = $vbulletin->options["bburl"].'/discuss.php?do=viewquestion&questionid='.$question['id'];
					//  keywords clickable
					$keywords = '';
					if(!empty($question["keywords"]))
					{
						$tagIds = $question["keywords"];
						$tagArray = explode(',', $tagIds);
						foreach($tagArray as $tid){
							$keywords .= "<span class='keywords'>&nbsp;<a class='smallfont' href='discuss.php?do=searchresults&keyword=". $tid ."'>#".$tid."</a>&nbsp;</span>&nbsp;";
						}
					}	
					// User Avatar
					$useravatarurl = fetch_avatar_url($question["userid"]);
					if (!$useravatarurl)
					{
						$useravatar = 'discuss/images/avatar.png';
					} else {
						$useravatar = $vbulletin->options['bburl'] . '/' . $useravatarurl[0];
					}			   
					$templater = vB_Template::create('discuss_browse_open');
					$templater->register('question_id', $question[id]);
					$templater->register('question_categoryid', $question[categoryid]);
					$templater->register('question_categoryname', $question[categoryname]);
					$templater->register('question_title', $question[title]);
					$templater->register('question_seolink', $seolink);
					$templater->register('question_keywords', $keywords);
					$templater->register('question_userid', $question[userid]);
					$templater->register('question_username', $question[username]);
					$templater->register('question_useravatar', $useravatar);
					$templater->register('question_replies', $question[replies]);
					$templater->register('question_featured', $question[featured]);
					$templater->register('question_views', $question[views]);
					$templater->register('question_resolved', $question[resolved]);
					$templater->register('question_postdate', time_stamp($question[postdate]));
					$browse_open .= $templater->render();
			}			
		}
		if ($cattab == 2)
		{
			$questionsperpage = $vbulletin->options['discuss_perpage'];
			$SubIds = array();
			$getSub = _getChildId($SubIds, $catid);
			$categories = implode($SubIds, ', ');
			$sql = "SELECT * FROM ".TABLE_PREFIX."discuss_questions WHERE categoryid IN ($categories) AND approved=1 AND hidden=0 AND resolved=1 ORDER BY postdate DESC";
			// Count records for pagination
			$totalquestions = $db->query_read($sql);
			$questions = $db->num_rows($totalquestions);
			$perpage= $questionsperpage;
			$pagenumber = $vbulletin->input->clean_gpc('r', 'pagenumber', TYPE_UINT);
			if (empty($pagenumber))
			{
				$pagenumber = 1;
			}
			$limitlower = ($pagenumber - 1) * $perpage+1;
			$limitupper = ($pagenumber) * $perpage;
			$counter = 0;
			if ($limitupper > $records)
			{
				$limitupper = $records;
				if ($limitlower > $records)
				{
					$limitlower = $records-$perpage;
				}
			}
			if ($limitlower <= 0)
			{
				$limitlower = 1;
			}
			$pagenav = construct_page_nav($pagenumber, $perpage, $records, 'discuss.php?' . $vbulletin->session->vars['sessionurl'] . 'do=main&catid='.$catid.'&cattab=2');
			// We must add limit to sql
			$sql .= ' LIMIT '. ($limitlower - 1) .', '.$perpage;
			// Execute Query
			$sql_questions = $db->query_read($sql);
			// Build Bits
			while ($question = $vbulletin->db->fetch_array($sql_questions)){
					$seolink = $vbulletin->options["bburl"].'/discuss.php?do=viewquestion&questionid='.$question['id'];
					//  keywords clickable
					$keywords = '';
					if(!empty($question["keywords"]))
					{
						$tagIds = $question["keywords"];
						$tagArray = explode(',', $tagIds);
						foreach($tagArray as $tid){
							$keywords .= "<span class='keywords'>&nbsp;<a class='smallfont' href='discuss.php?do=searchresults&keyword=". $tid ."'>#".$tid."</a>&nbsp;</span>&nbsp;";
						}
					}	
					// User Avatar
					$useravatarurl = fetch_avatar_url($question["userid"]);
					if (!$useravatarurl)
					{
						$useravatar = 'discuss/images/avatar.png';
					} else {
						$useravatar = $vbulletin->options['bburl'] . '/' . $useravatarurl[0];
					}			   
					$templater = vB_Template::create('discuss_browse_closed');
					$templater->register('question_id', $question[id]);
					$templater->register('question_categoryid', $question[categoryid]);
					$templater->register('question_categoryname', $question[categoryname]);
					$templater->register('question_title', $question[title]);
					$templater->register('question_seolink', $seolink);
					$templater->register('question_keywords', $keywords);
					$templater->register('question_userid', $question[userid]);
					$templater->register('question_username', $question[username]);
					$templater->register('question_useravatar', $useravatar);
					$templater->register('question_replies', $question[replies]);
					$templater->register('question_featured', $question[featured]);
					$templater->register('question_views', $question[views]);
					$templater->register('question_resolved', $question[resolved]);
					$templater->register('question_postdate', time_stamp($question[postdate]));
					$browse_closed .= $templater->render();
			}			
		}	   
    }
    // Top Experts
	$expertqueue = 0;
	$topexpert = 0;
    $maximum_experts = $vbulletin->options["discuss_experts"];		
    $sql_experts = $db->query_read("SELECT * FROM ".TABLE_PREFIX."user WHERE discuss_winner>0 ORDER BY discuss_winner DESC LIMIT $maximum_experts");
    while ($expert = $db->fetch_array($sql_experts)) {		
			$expertqueue ++;
			if ($expertqueue == 1)
			{
				$topexpert = 1;
			} else {
				$topexpert = 0;
			}	
			// User Avatar
			$expertavatarurl = fetch_avatar_url($expert["userid"]);
			if (!$expertavatarurl)
			{
				$expertavatar = 'discuss/images/avatar.png';
			} else {
				$expertavatar = $vbulletin->options['bburl'] . '/' . $expertavatarurl[0];
			}
			$templater = vB_Template::create('discuss_experts_block_bit');
			$templater->register('expert_userid', $expert[userid]);
			$templater->register('expert_username', $expert[username]);
			$templater->register('expert_joindate', date($vbulletin->options["discuss_dateshort"], $expert[joindate]));
			$templater->register('expert_usertitle', $expert[usertitle]);
			$templater->register('expert_avatar', $expertavatar);
			$templater->register('expert_replies', $expert[discuss_winner]);
			$templater->register('expert_top', $topexpert);
			$experts_block_bit .= $templater->render();				
	}
    $templater = vB_Template::create('discuss_experts_block');
    $templater->register('experts_block_bit', $experts_block_bit);
    $experts_block .= $templater->render();	
	// Statistics
    $total_questions = 0;
    $total_replies = 0;
    $total_open = 0;
	$total_closed = 0;
	$avg_replies = 0;
	$avg_closed = 0;
    $statistics = $db->query_read("SELECT * FROM ".TABLE_PREFIX."discuss_questions WHERE approved=1 AND hidden=0");
	while ($statistic = $db->fetch_array($statistics)) {
			$total_questions ++;
			if ($statistic["resolved"] == 1)
			{
				$total_closed ++;
			} else {
				$total_open ++;
			}
			$total_replies = $total_replies + $statistic["replies"];
	}
	if ($total_questions > 0 )
	{
		$avg_replies = round(($total_replies / $total_questions), 1);
		$avg_closed = round((($total_closed * 100)/$total_questions),1);
	}	
    $templater = vB_Template::create('discuss_statistics_block');
    $templater->register('total_questions', $total_questions);
    $templater->register('total_replies', $total_replies);
    $templater->register('total_open', $total_open);
	$templater->register('total_closed', $total_closed);
	$templater->register('avg_replies', $avg_replies);
	$templater->register('avg_closed', $avg_closed);
    $statistics_block .= $templater->render();
	// Search Block
    $tablename = "".TABLE_PREFIX."discuss_categories";
    $selectCat = new SelectCategory('categoryid', $tablename, 'true');
    $selectCat->SetMultiple(false, 30);
    $selectCat->SetFirstOption($vbphrase["discuss_all"], 0);
    $selectCat->SetSelected($catid);
    $selectCat->SetStyle('width:100%;');
    $selectcategory = $selectCat->Output();
    $templater = vB_Template::create('discuss_search_block');
    $templater->register('selectcategory', $selectcategory);
	$search_block .= $templater->render();
    // Page Templates
	$templater = vB_Template::create('discuss_main');
	$templater->register_page_templates();
    $navbits = construct_navbits(array("discuss.php?" . $vbulletin->session->vars['sessionurl'] . ""=> $vbulletin->options['discuss_navbar'], '', $mynavbar));
  	$navbar = render_navbar_template($navbits);
	$templater->register('navbar', $navbar);
	$templater->register('horizontalcategories', $horizontalcategories);
    $templater->register('browse_open', $browse_open);
	$templater->register('browse_closed', $browse_closed);
    $templater->register('catid', $catid);
    $templater->register('newest_questions', $newest_questions);
	$templater->register('popular_questions', $popular_questions);
    $templater->register('search_block', $search_block);
    $templater->register('experts_block', $experts_block);
    $templater->register('statistics_block', $statistics_block);
    $templater->register('followup_exists', $followup_exists);
	$templater->register('pagenav', $pagenav);
    $templater->register('categoryname',$categoryname);
	$templater->register('infotab', $infotab);
	$templater->register('showgrid', $showgrid);
	$templater->register('cattab', $cattab);
	print_output($templater->render());
}
//  #######################################################################
//  ##############################  View Question  ########################
//  #######################################################################
if ($_REQUEST['do'] == 'viewquestion')
{
    // First, let's clean input
    $questionid = $vbulletin->input->clean_gpc('r', 'questionid', TYPE_UINT);
    if(!$questionid)
    {
      $vbulletin->url="discuss.php?" . $vbulletin->session->vars['sessionurl'] . "do=main";
      eval(print_standard_redirect('discuss_invalid_data', true, true));
    }
    // Find Question
    $question = $db->query_first("SELECT * FROM " . TABLE_PREFIX . "discuss_questions WHERE id=$questionid LIMIT 1");
    if(!$question)
    {
      $vbulletin->url="discuss.php?" . $vbulletin->session->vars['sessionurl'] . "do=main";
      eval(print_standard_redirect('discuss_invalid_data', true, true));
    }
    // Is Owner?
    if($question["userid"] == $vbulletin->userinfo["userid"])
    {
       $owner = 1;
    } else {
       $owner = 0;
    }
	// Count View
    if($owner == 0)
    {
       // Update Views
       $vbulletin->db->query_write("UPDATE ".TABLE_PREFIX."discuss_questions SET views=views+1 WHERE id=$questionid");
    }
    // About Author Block
    $authorid = $question["userid"];
    $author = $db->query_first("SELECT * FROM ".TABLE_PREFIX."user WHERE userid=$authorid LIMIT 1");
    // Author Avatar
    $authoravatarurl = fetch_avatar_url($authorid);
    if (!$authoravatarurl)
    {
         $authoravatar = 'discuss/images/avatar.png';
    } else {
         $authoravatar = $vbulletin->options['bburl'] . '/' . $authoravatarurl[0];
    }
	// Prepare Template
    $templater = vB_Template::create('discuss_about_author_block');
    $templater->register('author_userid', $author[userid]);
    $templater->register('author_username', $author[username]);
    $templater->register('author_joindate', date($vbulletin->options["discuss_dateshort"], $author[joindate]));
    $templater->register('author_usertitle', $author[usertitle]);
    $templater->register('author_avatar', $authoravatar);
    $templater->register('author_questions', $author[discuss_questions]);
	$templater->register('author_replies', $author[discuss_replies]);
	$templater->register('author_answers', $author[discuss_winner]);
    $about_author_block .= $templater->render();
    // Author Other Questions Block
    $maxauthorother = $vbulletin->options["discuss_author_other"];
    $author_others = '';
    $author_others = $db->query_read("SELECT * FROM ".TABLE_PREFIX."discuss_questions WHERE userid=$authorid AND id<>$questionid AND hidden=0 AND approved=1 LIMIT $maxauthorother");
    while($author_other = $db->fetch_array($author_others)) {
		  $seolink = $vbulletin->options["bburl"].'/discuss.php?do=viewquestion&questionid='.$author_other['id'];
          $templater = vB_Template::create('discuss_author_questions_bit');
		  $templater->register('datarow_id', $author_other[id]);
		  $templater->register('datarow_categoryid', $author_other[categoryid]);
		  $templater->register('datarow_categoryname', $author_other[categoryname]);
		  $templater->register('datarow_title', $author_other[title]);
		  $templater->register('datarow_seolink', $seolink);
		  $templater->register('datarow_replies', $author_other[replies]);
		  $templater->register('datarow_resolved', $author_other[resolved]);
		  $templater->register('datarow_postdate', time_stamp($author_other[postdate]));
          $author_questions_bit .= $templater->render();
    }
    $templater = vB_Template::create('discuss_author_questions_block');
    $templater->register('author_id', $authorid);
    $templater->register('author_questions_bit', $author_questions_bit);
    $author_questions_block .= $templater->render();
	// Statistics
    $total_questions = 0;
    $total_replies = 0;
    $total_open = 0;
	$total_closed = 0;
	$avg_replies = 0;
	$avg_closed = 0;
    $statistics = $db->query_read("SELECT * FROM ".TABLE_PREFIX."discuss_questions WHERE approved=1 AND hidden=0");
	while ($statistic = $db->fetch_array($statistics)) {
			$total_questions ++;
			if ($statistic["resolved"] == 1)
			{
				$total_closed ++;
			} else {
				$total_open ++;
			}
			$total_replies = $total_replies + $statistic["replies"];
	}
	if ($total_questions > 0 )
	{
		$avg_replies = round(($total_replies / $total_questions), 1);
		$avg_closed = round((($total_closed * 100)/$total_questions),1);
	}	
    $templater = vB_Template::create('discuss_statistics_block');
    $templater->register('total_questions', $total_questions);
    $templater->register('total_replies', $total_replies);
    $templater->register('total_open', $total_open);
	$templater->register('total_closed', $total_closed);
	$templater->register('avg_replies', $avg_replies);
	$templater->register('avg_closed', $avg_closed);
    $statistics_block .= $templater->render();
	// Search Block
    $tablename = "".TABLE_PREFIX."discuss_categories";
    $selectCat = new SelectCategory('categoryid', $tablename, 'true');
    $selectCat->SetMultiple(false, 30);
    $selectCat->SetFirstOption($vbphrase["discuss_all"], 0);
    $selectCat->SetSelected($catid);
    $selectCat->SetStyle('width:100%;');
    $selectcategory = $selectCat->Output();
    $templater = vB_Template::create('discuss_search_block');
    $templater->register('selectcategory', $selectcategory);
	$search_block .= $templater->render();	
	// Prepare Bodytext
	require_once(DIR . '/includes/class_bbcode.php');
	$bbcode_parser = new vB_BbCodeParser($vbulletin, fetch_tag_list());
	$bodytext = $bbcode_parser->do_parse($question["bodytext"], false, true, true, true, true, $cachable);    
	// Setup Editor for Reply
    $editorid = construct_edit_toolbar('',1,'',1,1,($vbulletin->userinfo['userid']),'qr');
    // Browse Replies
    $answers = $db->query_read("SELECT * FROM ".TABLE_PREFIX."discuss_replies WHERE questionid=$questionid ORDER BY postdate ASC");
    while($answer = $db->fetch_array($answers)) {
			$resolve_valid = 0;
			if ($answer["userid"] != $question["userid"] && $question["resolved"] == 0)
			{
				$resolve_valid = 1;
			}
			// User Avatar
			$replieravatarurl = fetch_avatar_url($answer["userid"]);
			if (!$replieravatarurl)
			{
				$replieravatar = 'discuss/images/avatar.png';
			} else {
				$replieravatar = $vbulletin->options['bburl'] . '/' . $replieravatarurl[0];
			}			   
			// Prepare Bodytext
			require_once(DIR . '/includes/class_bbcode.php');
			$bbcode_parser = new vB_BbCodeParser($vbulletin, fetch_tag_list());
			$replybodytext = $bbcode_parser->do_parse($answer["bodytext"], false, true, true, true, true, $cachable);  			
			$templater = vB_Template::create('discuss_browse_replies');
			$templater->register('reply_id', $answer[id]);
			$templater->register('reply_userid', $answer[userid]);
			$templater->register('reply_username', $answer[username]);
			$templater->register('reply_useravatar', $replieravatar);
			$templater->register('reply_bodytext', $replybodytext);
			$templater->register('reply_postdate', time_stamp($answer[postdate]));
			$templater->register('resolve_valid', $resolve_valid);
			$templater->register('questionid', $questionid);
			$templater->register('reply_resolver', $answer[resolver]);
			$browse_replies .= $templater->render();
    }	
    // Custom Navbar
    $mynavbar = '';
    $mynavbar = getNavBar($mynavbar, $question["categoryid"]);
    $mynavbar .= '&nbsp;<img border="0" src="discuss/images/navbit-arrow.png">&nbsp;'.$question["title"];
    // Prepare Page Templates
    $templater = vB_Template::create('discuss_view_question');
    $templater->register_page_templates();
    $navbits = construct_navbits(array("discuss.php?" . $vbulletin->session->vars['sessionurl'] => $vbulletin->options['discuss_navbar'], '' => $mynavbar));
  	$navbar = render_navbar_template($navbits);
	$templater->register('navbar', $navbar);
    $templater->register('editorid', $editorid);
	$templater->register('messagearea', $messagearea);	
    $templater->register('id', $questionid);
    $templater->register('categoryid', $question[categoryid]);
	$templater->register('categoryname', $question[categoryname]);
	$templater->register('userid', $question[userid]);
	$templater->register('username', $question[username]);
    $templater->register('title', $question[title]);
    $templater->register('bodytext', $bodytext);
    $templater->register('postdate', time_stamp($question[postdate]));
	$templater->register('featured', $question[featured]);
    $templater->register('views', $question[views]);
    $templater->register('replies', $question[replies]);
	$templater->register('resolved', $question[resolved]);
    $templater->register('pagenav', $pagenav);
    $templater->register('pagenumber', $pagenumber);
    $templater->register('about_author_block', $about_author_block);
    $templater->register('author_questions_block', $author_questions_block);
    $templater->register('search_block', $search_block);
    $templater->register('statistics_block', $statistics_block);
	$templater->register('browse_replies', $browse_replies);
	print_output($templater->render());	
}	
//  ############################################################################
//  #################################  Save Reply  #############################
//  ############################################################################
if ($_REQUEST['do'] == 'savereply')
{
    if(!($permissions['discuss'] & $vbulletin->bf_ugp['discuss']['reply']))
    {
         print_no_permission();
    }
    $vbulletin->input->clean_array_gpc('p', array(
   		'wysiwyg'       => TYPE_BOOL,
        'message'		=> TYPE_STR,
        'questionid'    => TYPE_INT
	));
    // Get Values
    $questionid = $vbulletin->GPC['questionid'];
    if(!$questionid)
    {
      $vbulletin->url="discuss.php?" . $vbulletin->session->vars['sessionurl'] . "do=main";
      eval(print_standard_redirect('discuss_invalid_data', true, true));
    }	
	$question = $db->query_first("SELECT * FROM ".TABLE_PREFIX."discuss_questions WHERE id=$questionid LIMIT 1");
	$questiontitle = $db->escape_string($question["title"]);
    $userid = $vbulletin->userinfo['userid'];
    $username = $vbulletin->userinfo['username'];
	if (version_compare(@$vbulletin->versionnumber, '4.1.4', '>='))
	{
		require_once(DIR . '/includes/class_wysiwygparser.php');
		$html_parser = new vB_WysiwygHtmlParser($vbulletin);
		$vbulletin->GPC['message'] = $html_parser->parse_wysiwyg_html_to_bbcode($_POST['message'], 0);
	} else {
		require_once(DIR . '/includes/functions_wysiwyg.php');
		$vbulletin->GPC['message'] = convert_wysiwyg_html_to_bbcode($_POST['message'], 0);
	}
    require_once(DIR . '/includes/functions_newpost.php');
	$vbulletin->GPC['message'] = convert_url_to_bbcode($vbulletin->GPC['message']);
    $bodytext = $db->escape_string($vbulletin->GPC['message']);
    $postdate = time();
    // Save Reply
    $vbulletin->db->query_write("INSERT INTO " . TABLE_PREFIX . "discuss_replies
                                        SET questionid='$questionid',
                                            questiontitle = '$questiontitle',
                                            userid = '$userid',
                                            username = '$username',
                                            bodytext = '$bodytext',
                                            postdate = '$postdate'");
    $vbulletin->db->insert_id();
	// Update Replies counter
	// Questions
	$vbulletin->db->query_write("UPDATE ".TABLE_PREFIX."discuss_questions SET replies=replies+1 WHERE id=$questionid");
	// User
	$vbulletin->db->query_write("UPDATE ".TABLE_PREFIX."user SET discuss_replies=discuss_replies+1 WHERE userid=$userid");	
	// PM Owner for the new answer
    $fromuserid = 1;
    $fromusername = $vbphrase["discuss_system_notice"];
    $touserid = $question["userid"];
    $pmtemplate = $vbulletin->options["discuss_pm_new_reply"];
    $pmtitle = $vbphrase["discuss_info_newreply"].' '.$questiontitle;
    getSendPM($questionid,$pmtemplate,$pmtitle,$fromuserid,$fromusername,$touserid);	
    // Redirect Back
	$vbulletin->url="discuss.php?" . $vbulletin->session->vars['sessionurl'] . "do=viewquestion&questionid=$questionid";
	eval(print_standard_redirect('discuss_reply_ok', true, true));
}
//  ############################################################################
//  #########################  Mark Question as Solved  ########################
//  ############################################################################
if ($_REQUEST['do'] == 'markresolved')
{
    // First, let's clean input
    $questionid = $vbulletin->input->clean_gpc('r', 'questionid', TYPE_INT);
    $replyid = $vbulletin->input->clean_gpc('r', 'replyid', TYPE_INT);
    $userid = $vbulletin->userinfo["userid"];
    // Then, check for missing vales
    if(!$questionid)
    {
        $vbulletin->url="discuss.php?" . $vbulletin->session->vars['sessionurl'] . "do=main";
        eval(print_standard_redirect('discuss_invalid_data', true, true));
    }
    if(!$replyid)
    {
        $vbulletin->url="discuss.php?" . $vbulletin->session->vars['sessionurl'] . "do=viewquestion&questionid=$questionid";
        eval(print_standard_redirect('discuss_invalid_data', true, true));
    }
	// Find Question
	$question = $db->query_first("SELECT * FROM ".TABLE_PREFIX."discuss_questions WHERE id=$questionid LIMIT 1");
	// Check if User id the Owner
    if($userid <> $question["userid"])
    {
        print_no_permission();
    }
	// Everything is ok, so lets make some updates
	// Get Winner Data
	$reply = $db->query_first("SELECT * FROM ".TABLE_PREFIX."discuss_replies WHERE id=$replyid LIMIT 1");
	$winnerid = $reply["userid"];
	$winnername = $reply["username"];
	// Mark Reply as Winner
	$vbulletin->db->query_write("UPDATE ".TABLE_PREFIX."discuss_replies SET resolver=1 WHERE id=$replyid");
	// Mark Question as Resolved
	$vbulletin->db->query_write("UPDATE ".TABLE_PREFIX."discuss_questions 
										SET resolved = '1',
											resolverid = '$winnerid',
											resolvername = '$winnername' WHERE id=$questionid");
	// Mark User As Winner
	$vbulletin->db->query_write("UPDATE ".TABLE_PREFIX."user SET discuss_winner=discuss_winner+1 WHERE userid=$winnerid");
	// PM Winner
    $fromuserid = 1;
    $fromusername = $vbphrase["discuss_system_notice"];
    $touserid = $winnerid;
    $pmtemplate = $vbulletin->options["discuss_pm_winner"];
    $pmtitle = $vbphrase["discuss_info_winner"].' '.$question["title"];
    getSendPM($questionid,$pmtemplate,$pmtitle,$fromuserid,$fromusername,$touserid);	
    // Redirect Back
	$vbulletin->url="discuss.php?" . $vbulletin->session->vars['sessionurl'] . "do=viewquestion&questionid=$questionid";
	eval(print_standard_redirect('discuss_action_ok', true, true));
}
//  #######################################################################
//  #########################  Followup Category  #########################
//  #######################################################################
if ($_REQUEST['do'] == 'followup')
{
    // First, let's clean input
    $catid = $vbulletin->input->clean_gpc('r', 'catid', TYPE_INT);
    $action = $vbulletin->input->clean_gpc('r', 'action', TYPE_INT);
    $userid = $vbulletin->userinfo["userid"];
    // Then, check for missing vales
    if(!$catid)
    {
        $vbulletin->url="discuss.php?" . $vbulletin->session->vars['sessionurl'] . "do=main";
        eval(print_standard_redirect('discuss_invalid_data', true, true));
    }
    if(!$action)
    {
        $vbulletin->url="discuss.php?" . $vbulletin->session->vars['sessionurl'] . "do=main";
        eval(print_standard_redirect('discuss_invalid_data', true, true));
    }
    if(!$userid)
    {
        $vbulletin->url="discuss.php?" . $vbulletin->session->vars['sessionurl'] . "do=main";
        eval(print_standard_redirect('discuss_invalid_data', true, true));
    }
    if($action == 1)
    {
       // Add Followup
       $vbulletin->db->query_write("INSERT INTO " . TABLE_PREFIX . "discuss_watch SET userid=$userid, categoryid=$catid");
       $vbulletin->db->insert_id();
       $vbulletin->url="discuss.php?" . $vbulletin->session->vars['sessionurl'] . "do=main&catid=$catid";
       eval(print_standard_redirect('discuss_action_ok', true, true));
    }
    if($action == 2)
    {
       // Remove Followup
       $vbulletin->db->query_write("DELETE FROM " . TABLE_PREFIX . "discuss_watch WHERE id=$catid");
       $vbulletin->url="discuss.php?" . $vbulletin->session->vars['sessionurl'] . "do=mybookmarks";
       eval(print_standard_redirect('discuss_action_ok', true, true));
    }
    $vbulletin->url="discuss.php?" . $vbulletin->session->vars['sessionurl'] . "do=main";
    eval(print_standard_redirect('discuss_invalid_data', true, true));
}
//  #######################################################################
//  ###########################  Search Results  ##########################
//  #######################################################################
if ($_REQUEST['do'] == 'searchresults')
{
	global $sql;
    // Clean Post Values
    $vbulletin->input->clean_array_gpc('r', array(
        'categoryid' => TYPE_INT,
        'userid'     => TYPE_INT,
		'username'   => TYPE_STR,
        'keyword'	 => TYPE_STR,
		'open'    	 => TYPE_UINT,
		'resolved'   => TYPE_UINT,
        'timeframe'  => TYPE_INT,
        'orderby1'	 => TYPE_NOHTML,
        'orderby2'	 => TYPE_NOHTML,
        'adsperpage' => TYPE_INT
	));
    // Get Values
    $categoryid = $vbulletin->GPC['categoryid'];
    $userid = $vbulletin->GPC['userid'];
    $username = $db->escape_string($vbulletin->GPC['username']);
    $keyword = $db->escape_string($vbulletin->GPC['keyword']);	
    $open = $vbulletin->GPC['open'];
    $resolved = $vbulletin->GPC['resolved'];
    $timeframe = $vbulletin->GPC['timeframe'];
    $orderby1 = $db->escape_string($vbulletin->GPC['orderby1']);
    $orderby2 = $db->escape_string($vbulletin->GPC['orderby2']);
    $adsperpage = $vbulletin->GPC['adsperpage'];
    if(!$adsperpage)
    {
        $adsperpage = $vbulletin->options['discuss_perpage'];
    }
    // Lets start query with some standards
    $sql = "SELECT * FROM ".TABLE_PREFIX."discuss_questions WHERE approved=1 AND hidden=0";
    // And now lets add custom requests
    // Get Categories andSubcategories
    if($categoryid>0)
    {
       $SubIds = array();
       $getSub = _getChildId($SubIds, $categoryid);
       $categories = implode($SubIds, ', ');
       $sql .= " AND categoryid IN ($categories)";
    }
    if ($userid>0)
    {
        $sql .= " AND userid=$userid";
    }
    if (!empty($username))
    {
        $sql .= " AND (username LIKE '$username%' OR username LIKE '%$username%' OR username LIKE '%$username' OR username='$username')";
    }
    if ($timeframe>0)
    {
        $postdate = $timeframe*86400;
        $postdatelimit = time()-$postdate;
        $sql .= " AND postdate>=$postdatelimit";
    }
    if (!empty($keyword))
    {
        $words = split(' ', $keyword);
        foreach($words as $word)
        {
           $sql .= " AND (title LIKE '$word%' OR title LIKE '%$word%' OR title LIKE '%$word' OR title LIKE '$word' OR keywords LIKE '$word%' OR keywords LIKE '%$word%' OR keywords LIKE '%$word' OR keywords LIKE '$word')";
        }
    }
    if ($open == 0 || $resolved == 0)
    {	
		if ($open == 1 && $resolved == 0)
		{
			$sql .= " AND resolved=0";
		}
		if ($open == 0 && $resolved == 1)
		{
			$sql .= " AND resolved=1";
		}	
    }
	if(!$orderby1)
	{
		$orderby1 = 'postdate';
	}	
	if(!$orderby2)
	{
		$orderby2 = 'DESC';
	}		
    // User requests for ordering
    $order = $orderby1.' '.$orderby2;
    // Store post values for multipages
    $postvalues .= "&categoryid=".$categoryid;
    $postvalues .= "&userid=".$userid;
    $postvalues .= "&username=".$username;
    $postvalues .= "&keyword=".$keyword;
    $postvalues .= "&open=".$open;
    $postvalues .= "&resolved=".$resolved;
    $postvalues .= "&timeframe=".$timeframe;
    $postvalues .= "&orderby1=".$orderby1;
    $postvalues .= "&orderby2=".$orderby2;
    $postvalues .= "&adsperpage=".$adsperpage;
    $sql .= " ORDER BY $order";
    // Count records for pagination
    $totalquestions = $db->query_read($sql);
    $records = $db->num_rows($totalquestions);
    $perpage= $adsperpage;
    $pagenumber = $vbulletin->input->clean_gpc('r', 'pagenumber', TYPE_UINT);
    if (empty($pagenumber))
    {
        $pagenumber = 1;
    }
    $limitlower = ($pagenumber - 1) * $perpage+1;
    $limitupper = ($pagenumber) * $perpage;
    $counter = 0;
    if ($limitupper > $records)
	{
	    $limitupper = $records;
        if ($limitlower > $records)
	    {
	        $limitlower = $records-$perpage;
	    }
	}
	if ($limitlower <= 0)
	{
	    $limitlower = 1;
	}
    $pagenav = construct_page_nav($pagenumber, $perpage, $records, 'discuss.php?' . $vbulletin->session->vars['sessionurl'] . 'do=searchresults'.$postvalues.'');
    // We must add limit to sql
    $sql .= ' LIMIT '. ($limitlower - 1) .', '.$perpage;
    // Execute Query
    $questions = $db->query_read($sql);
    // Build Bits
	$headertitle = $vbphrase["discuss_search_results"];
    while ($question = $vbulletin->db->fetch_array($questions)){
			$seolink = $vbulletin->options["bburl"].'/discuss.php?do=viewquestion&questionid='.$question['id'];
			//  keywords clickable
			$keywords = '';
			if(!empty($question["keywords"]))
			{
				$tagIds = $question["keywords"];
				$tagArray = explode(',', $tagIds);
				foreach($tagArray as $tid){
					$keywords .= "<span class='keywords'>&nbsp;<a class='smallfont' href='discuss.php?do=searchresults&keyword=". $tid ."'>#".$tid."</a>&nbsp;</span>&nbsp;";
				}
			}	
			// User Avatar
			$useravatarurl = fetch_avatar_url($question["userid"]);
			if (!$useravatarurl)
			{
				$useravatar = 'discuss/images/avatar.png';
			} else {
				$useravatar = $vbulletin->options['bburl'] . '/' . $useravatarurl[0];
			}			   
			$templater = vB_Template::create('discuss_search_results_bit');
			$templater->register('question_id', $question[id]);
			$templater->register('question_categoryid', $question[categoryid]);
			$templater->register('question_categoryname', $question[categoryname]);
			$templater->register('question_title', $question[title]);
			$templater->register('question_seolink', $seolink);
			$templater->register('question_keywords', $keywords);
			$templater->register('question_userid', $question[userid]);
			$templater->register('question_username', $question[username]);
			$templater->register('question_useravatar', $useravatar);
			$templater->register('question_replies', $question[replies]);
			$templater->register('question_featured', $question[featured]);
			$templater->register('question_views', $question[views]);
			$templater->register('question_resolved', $question[resolved]);
			$templater->register('question_postdate', time_stamp($question[postdate]));
			$search_results_bit .= $templater->render();
	}
    // Top Experts
	$expertqueue = 0;
	$topexpert = 0;
    $maximum_experts = $vbulletin->options["discuss_experts"];		
    $sql_experts = $db->query_read("SELECT * FROM ".TABLE_PREFIX."user WHERE discuss_winner>0 ORDER BY discuss_winner DESC LIMIT $maximum_experts");
    while ($expert = $db->fetch_array($sql_experts)) {		
			$expertqueue ++;
			if ($expertqueue == 1)
			{
				$topexpert = 1;
			} else {
				$topexpert = 0;
			}	
			// User Avatar
			$expertavatarurl = fetch_avatar_url($expert["userid"]);
			if (!$expertavatarurl)
			{
				$expertavatar = 'discuss/images/avatar.png';
			} else {
				$expertavatar = $vbulletin->options['bburl'] . '/' . $expertavatarurl[0];
			}
			$templater = vB_Template::create('discuss_experts_block_bit');
			$templater->register('expert_userid', $expert[userid]);
			$templater->register('expert_username', $expert[username]);
			$templater->register('expert_joindate', date($vbulletin->options["discuss_dateshort"], $expert[joindate]));
			$templater->register('expert_usertitle', $expert[usertitle]);
			$templater->register('expert_avatar', $expertavatar);
			$templater->register('expert_replies', $expert[discuss_winner]);
			$templater->register('expert_top', $topexpert);
			$experts_block_bit .= $templater->render();				
	}
    $templater = vB_Template::create('discuss_experts_block');
    $templater->register('experts_block_bit', $experts_block_bit);
    $experts_block .= $templater->render();		
	// Statistics
    $total_questions = 0;
    $total_replies = 0;
    $total_open = 0;
	$total_closed = 0;
	$avg_replies = 0;
	$avg_closed = 0;
    $statistics = $db->query_read("SELECT * FROM ".TABLE_PREFIX."discuss_questions WHERE approved=1 AND hidden=0");
	while ($statistic = $db->fetch_array($statistics)) {
			$total_questions ++;
			if ($statistic["resolved"] == 1)
			{
				$total_closed ++;
			} else {
				$total_open ++;
			}
			$total_replies = $total_replies + $statistic["replies"];
	}
	if ($total_questions > 0 )
	{
		$avg_replies = round(($total_replies / $total_questions), 1);
		$avg_closed = round((($total_closed * 100)/$total_questions),1);
	}	
    $templater = vB_Template::create('discuss_statistics_block');
    $templater->register('total_questions', $total_questions);
    $templater->register('total_replies', $total_replies);
    $templater->register('total_open', $total_open);
	$templater->register('total_closed', $total_closed);
	$templater->register('avg_replies', $avg_replies);
	$templater->register('avg_closed', $avg_closed);
    $statistics_block .= $templater->render();
	// Search Block
    $tablename = "".TABLE_PREFIX."discuss_categories";
    $selectCat = new SelectCategory('categoryid', $tablename, 'true');
    $selectCat->SetMultiple(false, 30);
    $selectCat->SetFirstOption($vbphrase["discuss_all"], 0);
    $selectCat->SetSelected($catid);
    $selectCat->SetStyle('width:100%;');
    $selectcategory = $selectCat->Output();
    $templater = vB_Template::create('discuss_search_block');
    $templater->register('selectcategory', $selectcategory);
	$search_block .= $templater->render();	
    // Page Templates
	$headertitle = $vbphrase["discuss_search_results"];
	$templater = vB_Template::create('discuss_search_results');
	$templater->register_page_templates();
    $navbits = construct_navbits(array("discuss.php?" . $vbulletin->session->vars['sessionurl'] . ""=> $vbulletin->options['discuss_navbar'], '' => $headertitle));
  	$navbar = render_navbar_template($navbits);
	$templater->register('navbar', $navbar);
    $templater->register('headertitle', $headertitle);
    $templater->register('search_results_bit', $search_results_bit);
    $templater->register('pagenav', $pagenav);
    $templater->register('search_block', $search_block);
    $templater->register('experts_block', $experts_block);
    $templater->register('statistics_block', $statistics_block);	
	print_output($templater->render());
}
?>
