<?php
// ####################### SET PHP ENVIRONMENT ###########################
error_reporting(E_ALL & ~E_NOTICE);

// #################### DEFINE IMPORTANT CONSTANTS #######################
define('THIS_SCRIPT', 'discuss_modcp');
define('CSRF_PROTECTION', true);
define('PROJECT_SCRIPT', true);

// ################### PRE-CACHE TEMPLATES AND DATA ######################
// get special phrase groups
$phrasegroups = array(
	'discuss',
    'user',
	'postbit',
	'posting'
);

// get special data templates from the datastore
$specialtemplates = array(
    'smiliecache',
	'bbcodecache',
	'attachmentcache',
);

// pre-cache templates used by all actions
$globaltemplates = array(
    'usercp_nav_folderbit',
	'discuss.css',
    'discuss_approve_questions',
	'discuss_approve_questions_bit'
);

// pre-cache templates used by specific actions
$actiontemplates = array();

// ######################### REQUIRE BACK-END ############################
require_once('./global.php');
require_once('./includes/functions_editor.php');
require_once('./includes/functions_newpost.php');
require_once('./includes/functions_user.php');
require_once('./includes/class_bbcode.php');
require_once('./includes/class_image.php');
require_once('./includes/functions_bigthree.php');
require_once('./includes/functions_databuild.php'); 
require_once('./discuss/includes/functions.php');

// Check for Logon User
if (empty($vbulletin->userinfo['userid']))
{
	print_no_permission();
}
// Has access to Moderate?
if(!($permissions['discuss'] & $vbulletin->bf_ugp['discuss']['moderate']))
{
    print_no_permission();
}
// Set default action
if (empty($_REQUEST['do']))
{
	$_REQUEST['do'] = 'approvequestions';
}
//  ############################################################################
//  #############################  Approve Questions  ##########################
//  ############################################################################
if ($_REQUEST['do'] == 'approvequestions')
{
    // Check for permissions
    if(!($permissions['discuss'] & $vbulletin->bf_ugp['discuss']['moderate'])){
         print_no_permission();
    }
	$sql = "SELECT * FROM ".TABLE_PREFIX."discuss_questions WHERE approved=0 ORDER BY postdate ASC";
	// Count records for pagination
	$totalquestions = $db->query_read($sql);
	$questions = $db->num_rows($totalquestions);
	$perpage= $vbulletin->options["discuss_perpage"];
	$pagenumber = $vbulletin->input->clean_gpc('r', 'pagenumber', TYPE_UINT);
	if (empty($pagenumber))
	{
		$pagenumber = 1;
	}
	$limitlower = ($pagenumber - 1) * $perpage+1;
	$limitupper = ($pagenumber) * $perpage;
	$counter = 0;
	if ($limitupper > $records)
	{
		$limitupper = $records;
		if ($limitlower > $records)
		{
			$limitlower = $records-$perpage;
		}
	}
	if ($limitlower <= 0)
	{
		$limitlower = 1;
	}
	$pagenav = construct_page_nav($pagenumber, $perpage, $records, 'discuss_modcp.php?' . $vbulletin->session->vars['sessionurl'] . 'do=approvequestions');
	// We must add limit to sql
	$sql .= ' LIMIT '. ($limitlower - 1) .', '.$perpage;
	// Execute Query
	$sql_questions = $db->query_read($sql);
	// Build Bits
	while ($question = $vbulletin->db->fetch_array($sql_questions)){	   
			$templater = vB_Template::create('discuss_approve_questions_bit');
			$templater->register('id', $question[id]);
			$templater->register('categoryid', $question[categoryid]);
			$templater->register('categoryname', $question[categoryname]);
			$templater->register('userid', $question[userid]);
			$templater->register('username', $question[username]);
			$templater->register('title', $question[title]);
			$templater->register('approvetype', $question[approvetype]);
			$templater->register('postdate', time_stamp($question[postdate]));
			$approve_questions_bit .= $templater->render();
	}		
    // Page Templates
	$templater = vB_Template::create('discuss_approve_questions');
	$templater->register_page_templates();
    $navbits = construct_navbits(array("discuss.php?" . $vbulletin->session->vars['sessionurl'] . ""=> $vbulletin->options['discuss_navbar'], '', $vbphrase['discuss_approve_questions']));
  	$navbar = render_navbar_template($navbits);
	$templater->register('navbar', $navbar);
    $templater->register('approve_questions_bit', $approve_questions_bit);
	$templater->register('pagenav', $pagenav);
	print_output($templater->render());
}
//  ############################################################################
//  ###############################  Approve Question  #########################
//  ############################################################################
if ($_REQUEST['do'] == 'approvequestion')
{
    // Check for permissions
    if(!($permissions['discuss'] & $vbulletin->bf_ugp['discuss']['moderate'])){
         print_no_permission();
    }
    $questionid = $vbulletin->input->clean_gpc('r', 'questionid', TYPE_INT);
    // Check if Question exist
    if(!$questionid)
	{
        $vbulletin->url="discuss_modcp.php?" . $vbulletin->session->vars['sessionurl'] . "do=approvequestions";
        eval(print_standard_redirect('discuss_invalid_data', true, true));
    }
    $question = $db->query_first("SELECT * FROM ".TABLE_PREFIX."discuss_questions WHERE id=$questionid ORDER BY id ASC LIMIT 1");
    if(!$question)
    {
        $vbulletin->url="discuss_modcp.php?" . $vbulletin->session->vars['sessionurl'] . "do=approvequestions";
        eval(print_standard_redirect('discuss_invalid_data', true, true));
    }
	// Mark Question Approved
	$vbulletin->db->query_write("UPDATE ".TABLE_PREFIX."discuss_questions SET approved=1 WHERE id=$questionid");
	// Inform User
    $fromuserid = 1;
    $fromusername = $vbphrase["gallery_system_notice"];
    $touserid = $question["userid"];
    $pmtemplate = $vbulletin->options["discuss_pm_question_approved"];
    $pmtitle = $vbphrase["discuss_info_your_question"].' '.$question["title"].' '.$vbphrase["discuss_info_approved"];
    getSendPM($questionid,$pmtemplate,$pmtitle,$fromuserid,$fromusername,$touserid);	
    // Redirect back
    $vbulletin->url="discuss_modcp.php?" . $vbulletin->session->vars['sessionurl'] . "do=approvequestions";
    eval(print_standard_redirect('discuss_question_approved', true, true));
}
//  ############################################################################
//  ###############################  Reject Question  ##########################
//  ############################################################################
if ($_REQUEST['do'] == 'rejectquestion')
{
    // Check for permissions
    if(!($permissions['discuss'] & $vbulletin->bf_ugp['discuss']['moderate'])){
         print_no_permission();
    }
    $questionid = $vbulletin->input->clean_gpc('r', 'questionid', TYPE_INT);
    // Check if Question exist
    if(!$questionid)
	{
        $vbulletin->url="discuss_modcp.php?" . $vbulletin->session->vars['sessionurl'] . "do=approvequestions";
        eval(print_standard_redirect('discuss_invalid_data', true, true));
    }
    $question = $db->query_first("SELECT * FROM ".TABLE_PREFIX."discuss_questions WHERE id=$questionid ORDER BY id ASC LIMIT 1");
    if(!$question)
    {
        $vbulletin->url="discuss_modcp.php?" . $vbulletin->session->vars['sessionurl'] . "do=approvequestions";
        eval(print_standard_redirect('discuss_invalid_data', true, true));
    }
	// Inform User
    $fromuserid = 1;
    $fromusername = $vbphrase["gallery_system_notice"];
    $touserid = $question["userid"];
    $pmtemplate = $vbulletin->options["discuss_pm_question_rejected"];
    $pmtitle = $vbphrase["discuss_info_your_question"].' '.$question["title"].' '.$vbphrase["discuss_info_rejected"];
    getSendPM($questionid,$pmtemplate,$pmtitle,$fromuserid,$fromusername,$touserid);	
	// Delete Replies
	$vbulletin->db->query_write("DELETE FROM ".TABLE_PREFIX."discuss_replies WHERE questionid=$questionid");
	// Delete Question
	$vbulletin->db->query_write("DELETE FROM ".TABLE_PREFIX."discuss_questions WHERE id=$questionid");
    // Redirect back
    $vbulletin->url="discuss_modcp.php?" . $vbulletin->session->vars['sessionurl'] . "do=approvequestions";
    eval(print_standard_redirect('discuss_question_rejected', true, true));
}
?>
