<?php
// ####################### SET PHP ENVIRONMENT ###########################
error_reporting(E_ALL & ~E_NOTICE);

// #################### DEFINE IMPORTANT CONSTANTS #######################
define('THIS_SCRIPT', 'discuss_usercp');
define('CSRF_PROTECTION', true);
define('PROJECT_SCRIPT', true);

// ################### PRE-CACHE TEMPLATES AND DATA ######################
// get special phrase groups
$phrasegroups = array(
	'discuss',
    'user',
	'postbit',
	'posting'
);

// get special data templates from the datastore
$specialtemplates = array(
    'smiliecache',
	'bbcodecache',
	'attachmentcache',
);

// pre-cache templates used by all actions
$globaltemplates = array(
    'usercp_nav_folderbit',
	'discuss.css',
    'discuss_ask_question',
	'discuss_edit_question',
    'discuss_my_questions',
    'discuss_my_questions_bit',
    'discuss_my_bookmarks',
    'discuss_my_bookmarks_bit'
);

// pre-cache templates used by specific actions
$actiontemplates = array();
// ######################### REQUIRE BACK-END ############################
require_once('./global.php');
require_once('./includes/functions_editor.php');
require_once('./includes/functions_newpost.php');
require_once('./includes/functions_user.php');
require_once('./includes/class_bbcode.php');
require_once('./includes/class_image.php');
require_once('./includes/class_dm.php');
require_once('./includes/class_dm_pm.php');
require_once('./includes/functions_bigthree.php');
require_once('./includes/functions_databuild.php');
require_once('./discuss/includes/functions.php');

// Check for Logon User
if (empty($vbulletin->userinfo['userid']))
{
	print_no_permission();
}
// Has access to Discuss?
if(!($permissions['discuss'] & $vbulletin->bf_ugp['discuss']['access'])){
    print_no_permission();
}
// Set default action
if (empty($_REQUEST['do']))
{
	$_REQUEST['do'] = 'myquestions';
}
//  ############################################################################
//  #################################  Ask Question ############################
//  ############################################################################
if ($_REQUEST['do'] == 'askquestion')
{
    // Check for access permission
    if(!($permissions["discuss"] & $vbulletin->bf_ugp["discuss"]["post"]))
    {
         print_no_permission();
    }
	// Check for Fake Title from Homepage
    $vbulletin->input->clean_array_gpc('p', array(
		'faketitle'	=> TYPE_STR
	));
	$faketitle = $db->escape_string($vbulletin->GPC['faketitle']);
	// Where is comes from
	$urlid = $vbulletin->input->clean_gpc('r', 'urlid', TYPE_UINT);
	if(!$urlid)
	{
		$urlid = 1;
	}	
    // Setup Editor
	$editorid = construct_edit_toolbar('', false, 'nonforum', $vbulletin->options['allowsmilies']);
    // Get Categories for Drop Down
    $tablename = "".TABLE_PREFIX."discuss_categories";
    $selectCat = new SelectCategory('categoryid', $tablename, 'false');
    $selectCat->SetFirstOption($vbphrase["discuss_select_category"], 0);
    $selectCat->SetMultiple(false, 15);
    $selectCat->SetStyle('width:100%; padding:1px;');
    $selectcategory = $selectCat->Output();
    // Prepare Page Templates
    $templater = vB_Template::create('discuss_ask_question');
    $templater->register_page_templates();
    $navbits = construct_navbits(array("discuss.php?" . $vbulletin->session->vars['sessionurl'] => $vbulletin->options['discuss_navbar'], '' => $vbphrase['discuss_ask_question']));
  	$navbar = render_navbar_template($navbits);
	$templater->register('navbar', $navbar);
	$templater->register('editorid', $editorid);
	$templater->register('messagearea', $messagearea);
	$templater->register('faketitle', $faketitle);
	$templater->register('urlid', $urlid);
	$templater->register('selectcategory', $selectcategory);
    print_output($templater->render());
}
//  ############################################################################
//  ##############################  Save Question  #############################
//  ############################################################################
if ($_REQUEST['do'] == 'savequestion')
{
    if(!($permissions['discuss'] & $vbulletin->bf_ugp['discuss']['post']))
    {
         print_no_permission();
    }
    $vbulletin->input->clean_array_gpc('p', array(
   		'wysiwyg'       => TYPE_BOOL,
        'message'		=> TYPE_STR,
        'categoryid'    => TYPE_INT,
		'title'			=> TYPE_STR,
        'keywords'      => TYPE_STR
	));
    // Get Values
    $categoryid = $vbulletin->GPC['categoryid'];
	$category = $db->query_first("SELECT name FROM ".TABLE_PREFIX."discuss_categories WHERE id=$categoryid LIMIT 1");
	$categoryname = $category["name"];
	$urlid = $vbulletin->GPC['urlid'];
    $userid = $vbulletin->userinfo['userid'];
    $username = $vbulletin->userinfo['username'];
	$title = $db->escape_string($vbulletin->GPC['title']);
	if (version_compare(@$vbulletin->versionnumber, '4.1.4', '>='))
	{
		require_once(DIR . '/includes/class_wysiwygparser.php');
		$html_parser = new vB_WysiwygHtmlParser($vbulletin);
		$vbulletin->GPC['message'] = $html_parser->parse_wysiwyg_html_to_bbcode($_POST['message'], 0);
	} else {
		require_once(DIR . '/includes/functions_wysiwyg.php');
		$vbulletin->GPC['message'] = convert_wysiwyg_html_to_bbcode($_POST['message'], 0);
	}
    require_once(DIR . '/includes/functions_newpost.php');
	$vbulletin->GPC['message'] = convert_url_to_bbcode($vbulletin->GPC['message']);
    $bodytext = $db->escape_string($vbulletin->GPC['message']);
    $keywords = $db->escape_string($vbulletin->GPC['keywords']);
    $postdate = time();
    // Activate if does not needs approval
    if($permissions["discuss"] & $vbulletin->bf_ugp["discuss"]["approve"])
    {
        if($permissions["discuss"] & $vbulletin->bf_ugp["discuss"]["moderate"])
        {
             $approved = '1';
        } else {
             $approved = '0';
        }
    } else {
        $approved = '1';
    }
    // Save New Question?
    $bcat = 1;
    $approvetype = 1;
    $vbulletin->db->query_write("INSERT INTO " . TABLE_PREFIX . "discuss_questions
                                        SET categoryid='$categoryid',
                                            categoryname = '$categoryname',
                                            userid = '$userid',
                                            username = '$username',
                                            title = '$title',
                                            bodytext = '$bodytext',
                                            keywords = '$keywords',
                                            approved = '$approved',
                                            approvetype = '$approvetype',
                                            postdate = '$postdate',
                                            bcat = '$bcat'");
    $questionid=$vbulletin->GPC['id'] = $db->insert_id();
    // Redirect Back
	$vbulletin->url="discuss_usercp.php?" . $vbulletin->session->vars['sessionurl'] . "do=myquestions";
	if ($approved == 1)
	{
		eval(print_standard_redirect('discuss_question_post_approved', true, true));
	} else {
		eval(print_standard_redirect('discuss_question_post_moderated', true, true));
	}
}
//  ############################################################################
//  #################################  Edit Question  ##########################
//  ############################################################################
if ($_REQUEST['do'] == 'editquestion')
{
    // Check for access permission
    if(!($permissions["discuss"] & $vbulletin->bf_ugp["discuss"]["post"]))
    {
         print_no_permission();
    }
    $questionid = $vbulletin->input->clean_gpc('r', 'questionid', TYPE_INT);
    // Check if Question exist
    if(!$questionid)
    {
		$vbulletin->url="discuss_usercp.php?" . $vbulletin->session->vars['sessionurl'] . "do=myquestions";
		eval(print_standard_redirect('discuss_invalid_data', true, true));
    }
    $question = $db->query_first("SELECT * FROM ".TABLE_PREFIX."discuss_questions WHERE id=$questionid ORDER BY id ASC LIMIT 1");
    if(!$question)
    {
		$vbulletin->url="discuss_usercp.php?" . $vbulletin->session->vars['sessionurl'] . "do=myquestions";
		eval(print_standard_redirect('discuss_invalid_data', true, true));
    }
    // Who is the owner?
    $owner = $question["userid"];
    // Check if active user is the owner or if he has moderator permissions
    if(($owner != $vbulletin->userinfo['userid']) AND (!($permissions["discuss"] & $vbulletin->bf_ugp["discuss"]["moderate"])))
    {
        // Check failed. Send him back
        print_no_permission();
    }
    // Get Categories for Drop Down
    $tablename = "".TABLE_PREFIX."discuss_categories";
    $selectCat = new SelectCategory('categoryid', $tablename, 'false');
    $selectCat->SetFirstOption($vbphrase["discuss_select_category"], 0);
    $selectCat->SetSelected($question["categoryid"]);
    $selectCat->SetMultiple(false, 15);
    $selectCat->SetStyle('width:330px; padding:1px;');
    $selectcategory = $selectCat->Output();
    // Setup Editor
    $editorid = construct_edit_toolbar($question['bodytext'], false, 'nonforum', $vbulletin->options['allowsmilies']);
    // Page Templates
	$templater = vB_Template::create('discuss_edit_question');
	$templater->register_page_templates();
    $navbits = construct_navbits(array("discuss_usercp.php?" . $vbulletin->session->vars['sessionurl'] . ""=> $vbulletin->options['discuss_navbar'], '', $vbphrase['discuss_edit_question']));
  	$navbar = render_navbar_template($navbits);
	$templater->register('navbar', $navbar);
    $templater->register('editorid', $editorid);
	$templater->register('messagearea', $messagearea);
    $templater->register('selectcategory', $selectcategory);
    $templater->register('questionid', $questionid);
    $templater->register('title', $question[title]);
    $templater->register('keywords', $question[keywords]);
    $templater->register('status', $question[status]);
	print_output($templater->render());
}
//  ############################################################################
//  ###############################  Update Album  #############################
//  ############################################################################
if ($_REQUEST['do'] == 'updatequestion')
{
    if(!($permissions['discuss'] & $vbulletin->bf_ugp['discuss']['post']))
    {
         print_no_permission();
    }
    $vbulletin->input->clean_array_gpc('p', array(
   		'wysiwyg'       => TYPE_BOOL,
        'message'		=> TYPE_STR,
        'categoryid'    => TYPE_INT,
		'questionid'    => TYPE_INT,
		'title'			=> TYPE_STR,
        'keywords'      => TYPE_STR
	));
    // Get Values
    $categoryid = $vbulletin->GPC['categoryid'];
	$category = $db->query_first("SELECT name FROM ".TABLE_PREFIX."discuss_categories WHERE id=$categoryid LIMIT 1");
	$categoryname = $category["name"];
	$questionid = $vbulletin->GPC['questionid'];
    $userid = $vbulletin->userinfo['userid'];
    $username = $vbulletin->userinfo['username'];
	$title = $db->escape_string($vbulletin->GPC['title']);
	if (version_compare(@$vbulletin->versionnumber, '4.1.4', '>='))
	{
		require_once(DIR . '/includes/class_wysiwygparser.php');
		$html_parser = new vB_WysiwygHtmlParser($vbulletin);
		$vbulletin->GPC['message'] = $html_parser->parse_wysiwyg_html_to_bbcode($_POST['message'], 0);
	} else {
		require_once(DIR . '/includes/functions_wysiwyg.php');
		$vbulletin->GPC['message'] = convert_wysiwyg_html_to_bbcode($_POST['message'], 0);
	}
    require_once(DIR . '/includes/functions_newpost.php');
	$vbulletin->GPC['message'] = convert_url_to_bbcode($vbulletin->GPC['message']);
    $bodytext = $db->escape_string($vbulletin->GPC['message']);
    $keywords = $db->escape_string($vbulletin->GPC['keywords']);
    // Check if Question exist
    if(!$questionid)
    {
		$vbulletin->url="discuss_usercp.php?" . $vbulletin->session->vars['sessionurl'] . "do=myquestions";
		eval(print_standard_redirect('discuss_invalid_data', true, true));
    }
    $question = $db->query_first("SELECT * FROM ".TABLE_PREFIX."discuss_questions WHERE id=$questionid ORDER BY id ASC LIMIT 1");
    if(!$question)
    {
		$vbulletin->url="discuss_usercp.php?" . $vbulletin->session->vars['sessionurl'] . "do=myquestions";
		eval(print_standard_redirect('discuss_invalid_data', true, true));
    }
    // Who is the owner?
    $owner = $question["userid"];
    // Check if active user is the owner or if he has moderator permissions
    if(($owner != $vbulletin->userinfo['userid']) AND (!($permissions["discuss"] & $vbulletin->bf_ugp["discuss"]["moderate"])))
    {
        // Check failed. Send him back
        print_no_permission();
    }
    // Activate if does not needs approval
    if($permissions["discuss"] & $vbulletin->bf_ugp["discuss"]["approve"])
    {
        if($permissions["discuss"] & $vbulletin->bf_ugp["discuss"]["moderate"])
        {
             $approved = '1';
        } else {
             $approved = '0';
        }
    } else {
        $approved = '1';
    }
    // Update Question
    $approvetype = 2;
    $vbulletin->db->query_write("UPDATE " . TABLE_PREFIX . "discuss_questions
                                        SET categoryid='$categoryid',
                                            categoryname = '$categoryname',
                                            title = '$title',
                                            bodytext = '$bodytext',
                                            keywords = '$keywords',
                                            approved = '$approved',
                                            approvetype = '$approvetype' WHERE id=$questionid");
    // Redirect Back
	$vbulletin->url="discuss_usercp.php?" . $vbulletin->session->vars['sessionurl'] . "do=myquestions";
	if ($approved == 1)
	{
		eval(print_standard_redirect('discuss_question_update_approved', true, true));
	} else {
		eval(print_standard_redirect('discuss_question_update_moderated', true, true));
	}
}
//  ############################################################################
//  ###############################  Delete Question  ##########################
//  ############################################################################
if ($_REQUEST['do'] == 'deletequestion')
{
    // Check for access permission
    if(!($permissions["discuss"] & $vbulletin->bf_ugp["discuss"]["post"]))
    {
         print_no_permission();
    }
    $questionid = $vbulletin->input->clean_gpc('r', 'questionid', TYPE_INT);
    $url = $vbulletin->input->clean_gpc('r', 'url', TYPE_INT);
    if(!$url)
    {
        $url = 1;
    }
    // Check if Question exist
    if(!$questionid)
    {
      if($url == 1)
      {
         $vbulletin->url="discuss_usercp.php?" . $vbulletin->session->vars['sessionurl'] . "do=myquestions";
         eval(print_standard_redirect('discuss_invalid_data', true, true));
      }
      if($url == 2)
      {
         $vbulletin->url="discuss_modcp.php?" . $vbulletin->session->vars['sessionurl'] . "do=approvequestions";
         eval(print_standard_redirect('discuss_invalid_data', true, true));
      }
    }
    $question = $db->query_first("SELECT * FROM ".TABLE_PREFIX."discuss_questions WHERE id=$questionid ORDER BY id ASC LIMIT 1");
    if(!$question)
    {
      if($url == 1)
      {
         $vbulletin->url="discuss_usercp.php?" . $vbulletin->session->vars['sessionurl'] . "do=myquestions";
         eval(print_standard_redirect('discuss_invalid_data', true, true));
      }
      if($url == 2)
      {
         $vbulletin->url="discuss_modcp.php?" . $vbulletin->session->vars['sessionurl'] . "do=approvequestions";
         eval(print_standard_redirect('discuss_invalid_data', true, true));
      }
    }
    // Who is the owner?
    $owner = $question["userid"];
    // Check if active user is the owner or if he has moderator permissions
    if(($owner != $vbulletin->userinfo['userid']) AND (!($permissions["discuss"] & $vbulletin->bf_ugp["discuss"]["moderate"])))
    {
        // Check failed. Send him back
        print_no_permission();
    }
	// Winner
	$winnerid = $question["resolverid"];
	// Update Winner counter
	if($winnerid > 0)
	{
		$vbulletin->db->query_write("UPDATE " . TABLE_PREFIX . "user SET discuss_winner=discuss_winner-1 WHERE userid = $winnerid");
	}	
	// Delete Replies
	$vbulletin->db->query_write("DELETE FROM ".TABLE_PREFIX."discuss_replies WHERE questionid=$questionid");
	// Delete Question
	$vbulletin->db->query_write("DELETE FROM ".TABLE_PREFIX."discuss_questions WHERE id=$questionid");
    // Redirect back
    if($url == 1)
    {
        $vbulletin->url="discuss_usercp.php?" . $vbulletin->session->vars['sessionurl'] . "do=myquestions";
        eval(print_standard_redirect('discuss_question_removed', true, true));
    }
    if($url == 2)
    {
        $vbulletin->url="discuss_modcp.php?" . $vbulletin->session->vars['sessionurl'] . "do=approvequestions";
        eval(print_standard_redirect('discuss_question_removed', true, true));
    }
}
//  ############################################################################
//  ############################  Hide/Activate Question  ######################
//  ############################################################################
if ($_REQUEST['do'] == 'changestatus')
{
    // Check for access permission
    if(!($permissions["discuss"] & $vbulletin->bf_ugp["discuss"]["post"]))
    {
         print_no_permission();
    }
    // First, let's clean input
    $questionid = $vbulletin->input->clean_gpc('r', 'questionid', TYPE_UINT);
    $action = $vbulletin->input->clean_gpc('r', 'action', TYPE_UINT);
    // Then, check for missing vales
    if(!$questionid)
    {
      $vbulletin->url="discuss_usercp.php?" . $vbulletin->session->vars['sessionurl'] . "do=myquestions";
      eval(print_standard_redirect('discuss_invalid_data', true, true));
    }
    if(!$action)
    {
      $vbulletin->url="discuss_usercp.php?" . $vbulletin->session->vars['sessionurl'] . "do=myquestions";
      eval(print_standard_redirect('discuss_invalid_data', true, true));
    }
    // Find Question
    $question = $db->query_first("SELECT * FROM " . TABLE_PREFIX . "discuss_questions WHERE id=$questionid LIMIT 1");
    // Who is the owner?
    $owner = $question["userid"];
    // Check if active user is the owner
    if($owner != $vbulletin->userinfo['userid'])
    {
        // Check failed. Send him back
        print_no_permission();
    }
    // Everything is ok, lets Hide / Activate it
    if ($action==1)
    {
		// Hide Question
		$vbulletin->db->query_write("UPDATE " . TABLE_PREFIX . "discuss_questions SET hidden=1 WHERE id = $questionid");
    }
    if($action==2)
    {
		// Activate Question
		$vbulletin->db->query_write("UPDATE " . TABLE_PREFIX . "discuss_questions SET hidden=0 WHERE id = $questionid");
    }
    // Redirect Back
	$vbulletin->url="discuss_usercp.php?" . $vbulletin->session->vars['sessionurl'] . "do=myquestions";
    if ($action == 1)
    {
        eval(print_standard_redirect('discuss_hide_ok', true, true));
    } else {
		eval(print_standard_redirect('discuss_activate_ok', true, true));
    }
}
//  ############################################################################
//  ###############################  Re-Open Question  #########################
//  ############################################################################
if ($_REQUEST['do'] == 'reopen')
{
    // Check for access permission
    if(!($permissions["discuss"] & $vbulletin->bf_ugp["discuss"]["post"]))
    {
         print_no_permission();
    }
    // First, let's clean input
    $questionid = $vbulletin->input->clean_gpc('r', 'questionid', TYPE_UINT);
    // Then, check for missing vales
    if(!$questionid)
    {
      $vbulletin->url="discuss_usercp.php?" . $vbulletin->session->vars['sessionurl'] . "do=myquestions";
      eval(print_standard_redirect('discuss_invalid_data', true, true));
    }
    // Find Question
    $question = $db->query_first("SELECT * FROM " . TABLE_PREFIX . "discuss_questions WHERE id=$questionid LIMIT 1");
    // Who is the owner?
    $owner = $question["userid"];
    // Check if active user is the owner
    if($owner != $vbulletin->userinfo['userid'])
    {
        // Check failed. Send him back
        print_no_permission();
    }
	// Winner
	$winnerid = $question["resolverid"];
	// Update Winner counter
	if($winnerid > 0)
	{
		$vbulletin->db->query_write("UPDATE " . TABLE_PREFIX . "user SET discuss_winner=discuss_winner-1 WHERE userid = $winnerid");
	}
	// Everything is ok, lets Re-Open it
	$vbulletin->db->query_write("UPDATE " . TABLE_PREFIX . "discuss_questions SET resolved=0, resolverid=0, resolvername='' WHERE id = $questionid");
	// Unmark Won Reply
	$vbulletin->db->query_write("UPDATE " . TABLE_PREFIX . "discuss_replies SET resolver=0 WHERE questionid=$questionid AND resolver=1");
    // Redirect Back
	$vbulletin->url="discuss_usercp.php?" . $vbulletin->session->vars['sessionurl'] . "do=myquestions";
    eval(print_standard_redirect('discuss_reopen_ok', true, true));
}
//  ############################################################################
//  ##################################  My Questions  ##########################
//  ############################################################################
if ($_REQUEST['do'] == 'myquestions')
{
    // Get Values
    $userid = $vbulletin->userinfo['userid'];
    // Check Missing value
    if(!$userid)
    {
        print_no_permission();
    }
	$sql = "SELECT * FROM ".TABLE_PREFIX."discuss_questions WHERE userid=$userid ORDER BY postdate DESC";
	// Count records for pagination
	$totalquestions = $db->query_read($sql);
	$questions = $db->num_rows($totalquestions);
	$perpage= $vbulletin->options["discuss_perpage"];
	$pagenumber = $vbulletin->input->clean_gpc('r', 'pagenumber', TYPE_UINT);
	if (empty($pagenumber))
	{
		$pagenumber = 1;
	}
	$limitlower = ($pagenumber - 1) * $perpage+1;
	$limitupper = ($pagenumber) * $perpage;
	$counter = 0;
	if ($limitupper > $records)
	{
		$limitupper = $records;
		if ($limitlower > $records)
		{
			$limitlower = $records-$perpage;
		}
	}
	if ($limitlower <= 0)
	{
		$limitlower = 1;
	}
	$pagenav = construct_page_nav($pagenumber, $perpage, $records, 'discuss_usercp.php?' . $vbulletin->session->vars['sessionurl'] . 'do=myquestions');
	// We must add limit to sql
	$sql .= ' LIMIT '. ($limitlower - 1) .', '.$perpage;
	// Execute Query
	$sql_questions = $db->query_read($sql);
	// Build Bits
	while ($question = $vbulletin->db->fetch_array($sql_questions)){	   
			$templater = vB_Template::create('discuss_my_questions_bit');
			$templater->register('id', $question[id]);
			$templater->register('categoryid', $question[categoryid]);
			$templater->register('categoryname', $question[categoryname]);
			$templater->register('title', $question[title]);
			$templater->register('replies', $question[replies]);
			$templater->register('views', $question[views]);
			$templater->register('resolved', $question[resolved]);
			$templater->register('approved', $question[approved]);
			$templater->register('hidden', $question[hidden]);
			$templater->register('postdate', time_stamp($question[postdate]));
			$my_questions_bit .= $templater->render();
	}		
    // Page Templates
	$templater = vB_Template::create('discuss_my_questions');
	$templater->register_page_templates();
    $navbits = construct_navbits(array("discuss.php?" . $vbulletin->session->vars['sessionurl'] . ""=> $vbulletin->options['discuss_navbar'], '', $vbphrase['discuss_my_questions']));
  	$navbar = render_navbar_template($navbits);
	$templater->register('navbar', $navbar);
    $templater->register('my_questions_bit', $my_questions_bit);
	$templater->register('pagenav', $pagenav);
	print_output($templater->render());
}
//  #######################################################################
//  ##############################  My Bookmarks  #########################
//  #######################################################################
if ($_REQUEST['do'] == 'mybookmarks')
{
    // Get Values
    $userid = $vbulletin->userinfo['userid'];
    // Check Missing value
    if(!$userid)
    {
        print_no_permission();
    }
	$sql = "SELECT * FROM ".TABLE_PREFIX."discuss_watch WHERE userid=$userid ORDER BY id ASC";
	// Count records for pagination
	$totalquestions = $db->query_read($sql);
	$questions = $db->num_rows($totalquestions);
	$perpage= $vbulletin->options["discuss_perpage"];
	$pagenumber = $vbulletin->input->clean_gpc('r', 'pagenumber', TYPE_UINT);
	if (empty($pagenumber))
	{
		$pagenumber = 1;
	}
	$limitlower = ($pagenumber - 1) * $perpage+1;
	$limitupper = ($pagenumber) * $perpage;
	$counter = 0;
	if ($limitupper > $records)
	{
		$limitupper = $records;
		if ($limitlower > $records)
		{
			$limitlower = $records-$perpage;
		}
	}
	if ($limitlower <= 0)
	{
		$limitlower = 1;
	}
	$pagenav = construct_page_nav($pagenumber, $perpage, $records, 'discuss_usercp.php?' . $vbulletin->session->vars['sessionurl'] . 'do=mybookmarks');
	// We must add limit to sql
	$sql .= ' LIMIT '. ($limitlower - 1) .', '.$perpage;
	// Execute Query
	$bookmarks = $db->query_read($sql);
	// Build Bits
	while ($bookmark = $vbulletin->db->fetch_array($bookmarks)){
			$output = '';
			$categorylink = getNoLinkNavBar($output,$bookmark[categoryid]);
			$templater = vB_Template::create('discuss_my_bookmarks_bit');
			$templater->register('id', $bookmark[id]);
			$templater->register('category', $categorylink);
			$my_bookmarks_bit .= $templater->render();
	}		
    // Page Templates
	$templater = vB_Template::create('discuss_my_bookmarks');
	$templater->register_page_templates();
    $navbits = construct_navbits(array("discuss.php?" . $vbulletin->session->vars['sessionurl'] . ""=> $vbulletin->options['discuss_navbar'], '', $vbphrase['discuss_my_bookmarks']));
  	$navbar = render_navbar_template($navbits);
	$templater->register('navbar', $navbar);
    $templater->register('my_bookmarks_bit', $my_bookmarks_bit);
	$templater->register('pagenav', $pagenav);
	print_output($templater->render());
}
?>
